#import "AppDelegate.h"
#import "SaleViewController.h"
#import "StatusViewController.h"

@implementation SaleViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [_usernameField setDelegate:self];
    [_passwordField setDelegate:self];
    [_amountField setDelegate:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(BOOL) textFieldShouldReturn:(UITextField *)textField {
    if (textField.returnKeyType == UIReturnKeyNext) {
        if (textField == _usernameField) {
            [_usernameField resignFirstResponder];
            [_passwordField becomeFirstResponder];
        } else if (textField == _passwordField) {
            [_passwordField resignFirstResponder];
            [_amountField becomeFirstResponder];
        }
    }
    if (textField.returnKeyType == UIReturnKeyGo && textField == _amountField)
        [self doSubmitPayment:self];

    return YES;
}

- (BOOL)shouldPerformSegueWithIdentifier:(NSString *)identifier sender:(id)sender {
    /* We don't want this segue to happen automatically from being linked in
     * the storyboard because if the alert popup stops the segue it produces
     * warnings and we don't know exactly what will happen because it appears
     * to be a race condition. Instead we prevent it from happening and run it
     * programmatically (this function will not be called) when necessary. */
    if ([identifier isEqualToString:@"pushResult"])
        return NO;
    return YES;
}

- (IBAction)doSubmitPayment:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];

    [req setObject:@"txnrequest" forKey:@"u_action"];
    [req setObject:@"sale" forKey:@"action"];
    [req setObject:_amountField.text forKey:@"amount"];
    [req setObject:@"1" forKey:@"u_id"];
    [req setObject:@"bt:com.ingenico.easypayemv.spm-transaction" forKey:@"u_device"];
    //[req setObject:@"ip:10.200.10.184:12000" forKey:@"u_device"];
    [req setObject:@"ingenico_rba" forKey:@"u_devicetype"];
    [req setObject:_usernameField.text forKey:@"username"];
    [req setObject:_passwordField.text forKey:@"password"];
    
    /* Create the view and display it */
    StatusViewController *svc = [self.storyboard instantiateViewControllerWithIdentifier:@"statusScene"];

    svc.requestKVS = req;
    
    svc.navigationItem.leftBarButtonItem = nil;
    svc.navigationItem.hidesBackButton = YES;
    
    [self.navigationController pushViewController:svc animated:NO];
}

@end
